package main

// Code generated by Gojay.

import (
	"github.com/francoispqt/gojay"
	"time"
)

type AddresssPtr []*Address

func (s *AddresssPtr) UnmarshalJSONArray(dec *gojay.Decoder) error {
	var value = &Address{}
	if err := dec.Object(value); err != nil {
		return err
	}
	*s = append(*s, value)
	return nil
}

func (s AddresssPtr) MarshalJSONArray(enc *gojay.Encoder) {
	for i := range s {
		enc.Object(s[i])
	}
}

func (s AddresssPtr) IsNil() bool {
	return len(s) == 0
}

type Strings []string

// UnmarshalJSONArray decodes JSON array elements into slice
func (a *Strings) UnmarshalJSONArray(dec *gojay.Decoder) error {
	var value string
	if err := dec.String(&value); err != nil {
		return err
	}
	*a = append(*a, value)
	return nil
}

// MarshalJSONArray encodes arrays into JSON
func (a Strings) MarshalJSONArray(enc *gojay.Encoder) {
	for _, item := range a {
		enc.String(item)
	}
}

// IsNil checks if array is nil
func (a Strings) IsNil() bool {
	return len(a) == 0
}

// MarshalJSONObject implements MarshalerJSONObject
func (a *Address) MarshalJSONObject(enc *gojay.Encoder) {
	enc.StringKey("Name", a.Name)
	enc.StringKey("Email", a.Email)
}

// IsNil checks if instance is nil
func (a *Address) IsNil() bool {
	return a == nil
}

// UnmarshalJSONObject implements gojay's UnmarshalerJSONObject
func (a *Address) UnmarshalJSONObject(dec *gojay.Decoder, k string) error {

	switch k {
	case "Name":
		return dec.String(&a.Name)

	case "Email":
		return dec.String(&a.Email)

	}
	return nil
}

// NKeys returns the number of keys to unmarshal
func (a *Address) NKeys() int { return 2 }

// MarshalJSONObject implements MarshalerJSONObject
func (m *Mail) MarshalJSONObject(enc *gojay.Encoder) {
	enc.StringKey("Sender", m.Sender)
	enc.StringKey("Recipient", m.Recipient)
	enc.ObjectKey("Message", m.Message)
}

// IsNil checks if instance is nil
func (m *Mail) IsNil() bool {
	return m == nil
}

// UnmarshalJSONObject implements gojay's UnmarshalerJSONObject
func (m *Mail) UnmarshalJSONObject(dec *gojay.Decoder, k string) error {

	switch k {
	case "Sender":
		return dec.String(&m.Sender)

	case "Recipient":
		return dec.String(&m.Recipient)

	case "Message":
		var value = &Message{}
		err := dec.Object(value)
		if err == nil {
			m.Message = value
		}

		return err

	}
	return nil
}

// NKeys returns the number of keys to unmarshal
func (m *Mail) NKeys() int { return 3 }

// MarshalJSONObject implements MarshalerJSONObject
func (m *Message) MarshalJSONObject(enc *gojay.Encoder) {
	var fromSlice = AddresssPtr(m.From)
	enc.ArrayKey("From", fromSlice)
	var toSlice = AddresssPtr(m.To)
	enc.ArrayKey("To", toSlice)
	var ccSlice = AddresssPtr(m.Cc)
	enc.ArrayKey("Cc", ccSlice)
	var bccSlice = AddresssPtr(m.Bcc)
	enc.ArrayKey("Bcc", bccSlice)
	var replyToSlice = AddresssPtr(m.ReplyTo)
	enc.ArrayKey("ReplyTo", replyToSlice)
	enc.StringKey("Subject", m.Subject)
	enc.TimeKey("Date", &m.Date, time.RFC3339)
	enc.StringKey("MessageID", m.MessageID)
	enc.StringKey("InReplyTo", m.InReplyTo)
	var referencesSlice = Strings(m.References)
	enc.ArrayKey("References", referencesSlice)
	enc.StringKey("Text", m.Text)
	enc.StringKey("HTML", m.HTML)
}

// IsNil checks if instance is nil
func (m *Message) IsNil() bool {
	return m == nil
}

// UnmarshalJSONObject implements gojay's UnmarshalerJSONObject
func (m *Message) UnmarshalJSONObject(dec *gojay.Decoder, k string) error {

	switch k {
	case "From":
		var aSlice = AddresssPtr{}
		err := dec.Array(&aSlice)
		if err == nil && len(aSlice) > 0 {
			m.From = []*Address(aSlice)
		}
		return err

	case "To":
		var aSlice = AddresssPtr{}
		err := dec.Array(&aSlice)
		if err == nil && len(aSlice) > 0 {
			m.To = []*Address(aSlice)
		}
		return err

	case "Cc":
		var aSlice = AddresssPtr{}
		err := dec.Array(&aSlice)
		if err == nil && len(aSlice) > 0 {
			m.Cc = []*Address(aSlice)
		}
		return err

	case "Bcc":
		var aSlice = AddresssPtr{}
		err := dec.Array(&aSlice)
		if err == nil && len(aSlice) > 0 {
			m.Bcc = []*Address(aSlice)
		}
		return err

	case "ReplyTo":
		var aSlice = AddresssPtr{}
		err := dec.Array(&aSlice)
		if err == nil && len(aSlice) > 0 {
			m.ReplyTo = []*Address(aSlice)
		}
		return err

	case "Subject":
		return dec.String(&m.Subject)

	case "Date":
		var format = time.RFC3339
		var value = time.Time{}
		err := dec.Time(&value, format)
		if err == nil {
			m.Date = value
		}
		return err

	case "MessageID":
		return dec.String(&m.MessageID)

	case "InReplyTo":
		return dec.String(&m.InReplyTo)

	case "References":
		var aSlice = Strings{}
		err := dec.Array(&aSlice)
		if err == nil && len(aSlice) > 0 {
			m.References = []string(aSlice)
		}
		return err

	case "Text":
		return dec.String(&m.Text)

	case "HTML":
		return dec.String(&m.HTML)

	}
	return nil
}

// NKeys returns the number of keys to unmarshal
func (m *Message) NKeys() int { return 12 }
